;;;; range.scm
;;;; Kon Lovett, Apr 6 '06

;; Range (Oleg Kiselyov)

(module range

(;export
  (range-empty? $range-empty-tag)
  (range $range-empty-tag)
  $range-empty-tag)

(import scheme
  (chicken base)
  bshift-breset)

;;
;; Unique value for range macro
;;

(define ($range-empty-tag) $range-empty-tag)

;;

(define-syntax range-empty?
  (syntax-rules ()
    ((range-empty? RV) (eq? $range-empty-tag RV)) ) )

;FIXME FROM TO [STEP] ...
(define-syntax range
  (syntax-rules ()
    ; FROM (--> 'a), STEP ('a --> 'a), TO? ('a --> boolean), VALUE ('a --> *)
    ((range RC FROM VALUE STEP TO?)
      (bshift RC shifter
              (do ((state (FROM) (STEP state)))
                  ((TO? state) $range-empty-tag)
                (shifter (VALUE state)))) )
    ; FROM number, STEP number, TO number
    ((range RC FROM STEP TO)
      (bshift RC shifter
              (do ((i FROM (+ i STEP)))
                  ((> i TO) $range-empty-tag)
                (shifter i))) )
    ; FROM number, STEP 1, TO number
    ((range RC FROM TO)
      (range RC FROM 1 TO)) ) )

) ;module range
